<?php

if ( !class_exists( 'initModel' ) ) :

    class initModel {

        /**
         * Generate nonce field
         */
        function controllersOrder() {
            return [
                'pmPreloadsController',
                'pmPostMetaController',
                'pmPostTypeController',
                'pmTaxonomyController',
                'pmPostController',
                'pmImportExportController',
                'pmSettingsController',
                'pmVersionController',
                'postMetaPro'
            ];
        }


        /**
         * Calling views. if pro then render from pro directory
         */


        function create_input( $name = '', $type = 'text', $attr = [], $options = [] ) {
            $name = trim( $name );
            $name = $name ? "name=\"$name\"" : '';

            if ( isset( $attr['value'] ) ) {
                if ( is_string( $attr['value'] ) ) $attr['value'] = esc_attr( trim( $attr['value'] ) );
            }
            $value = $attr['value'] ?? null;

            //filter attr for add
            $excludeAttr = [ 'before', 'after', 'enclose', 'field_enclose', 'field_control', 'label', 'by_key', 'label_class', 'label_enclose', 'label_extra', 'combind', 'option_before', 'option_after', 'file_filter' ];
            $excludeType = [ 'select', 'radio', 'label', 'checkbox', 'textarea' ];  //exclude adding value
            if ( in_array( $type, $excludeType ) ) $excludeAttr[] = 'value';
            $include = null;
            if ( $attr ) {
                foreach ( $attr as $key => $val ) {
                    if ( !in_array( $key, $excludeAttr ) ) {
                        $include .= $val ? "$key='$val' " : "";
                    }
                }
            }

            $option_before = $attr['option_before'] ?? null;
            $option_after = $attr['option_after'] ?? null;
            $by_key = $attr['by_key'] ?? null;
            $label_class = $attr['label_class'] ?? null;
            $label_extra = $attr['label_extra'] ?? null;
            $field_enclose = $attr['field_enclose'] ?? null;
            $field_control = $attr['field_control'] ?? null;
            $file_filter = $attr['file_filter'] ?? null;

            $html = '';
            if ( $type == 'select' ) {
                $html .= "<select $name $include>";
                if ( isset( $options ) ) {
                    foreach ( $options as $key => $val ) {
                        if ( !$by_key ) $key = $val;
                        $key = is_string( $key ) ? trim( $key ) : $key;
                        $selected = ( $key == $value ) ? "selected='selected'" : "";
                        $html .= "<option value='$key' $selected>$val</option>";
                    }
                } else {
                    $html .= "No option set yet";
                }
                $html .= "</select>";
            } elseif ( $type == 'radio' ) {
                if ( isset( $options ) ) {
                    foreach ( $options as $key => $val ) {
                        if ( !$by_key ) $key = $val;
                        $key = is_string( $key ) ? trim( $key ) : $key;
                        $checked = ( $key == $value ) ? "checked='checked'" : "";
                        $html .= "$option_before<input type='$type' $name $include value='$key' $checked /> $val $option_after";
                    }
                } else {
                    $html .= "No option set yet";
                }
            } elseif ( $type == 'checkbox' ) {
                $attr['combind'] = $attr['combind'] ?? false;
                if ( $attr['combind'] ) {
                    $name = rtrim( $name, "\"" ) . "[]\"";
                    if ( isset( $options ) ) {
                        foreach ( $options as $key => $val ) {
                            if ( !$by_key ) $key = $val;
                            $key = is_string( $key ) ? trim( $key ) : $key;
                            if ( is_array( $value ) )
                                $checked = in_array( $key, $value ) ? "checked='checked'" : "";
                            else
                                $checked = ( $key == $value ) ? "checked='checked'" : "";
                            $html .= "$option_before<input type='$type' {$name} $include value='$key' $checked /> $val $option_after";
                        }
                    } else {
                        $html .= "No option set yet";
                    }
                } else {
                    $checked = $value ? "checked='checked'" : "";
                    $html .= "<input type='$type' $name $include $checked />";
                }
            } elseif ( $type == 'textarea' ) {
                $html .= "<textarea $name $include>$value</textarea>";
            } elseif ( $type == 'label' ) {
                $for = isset( $attr['for'] ) ? "for='{$attr['for']}'" : '';
                $html .= "<label $for $include>$value</label>";
            } elseif ( $type == 'hidden' ) {
                $html .= "<input type='$type' $name $include />";

            } elseif ( $type == 'image_media' ) {
                global $postMeta;
                if ( $attr['value'] ) {
                    $style = "block";
                    $preview_url = $postMeta->generate_thumb( $attr['value'], 150, 150 );
                } else {
                    $style = "none";
                    $preview_url = PM_ASSECTS_URL . 'images/no_preview.png';
                }
                $html .= sprintf( '<div class="file_wrapper">
                                            <div class="file_preview">
                                                <div class="file_thum_manage" style="display:%s;><a target="_blank" href="%s" class="dl">View</a><a href="#delete" class="delete" onclick="pmDeleteFile(this); return false">delete</a></div>
                                                <div class="file_preview_thum"><img alt="Media image" src="%s"/></div>
                                            </div>
                                            <div class="file_input">
                                                <div id="upload_response_%s"></div>
                                                <input type="hidden" %s %s value="" />
                                                <div id="media_upload_%s" class="button pc_media_upload_button" type="button" name="pc_media_upload_button">Upload Image via media </div>
                                            </div>
                                        </div>', esc_attr( $style ), esc_attr( $attr['value'] ), esc_url( $preview_url ), esc_attr( $attr['id'] ),
                    esc_attr( $name ), esc_attr( $include ), esc_attr($attr['id'])
                );

            } else {
                $html .= "<input type='$type' $name $include />";
            }


            $before = $attr['before'] ?? null;
            $after = $attr['after'] ?? null;
            $html = $before . $html . $after;

            //Enclose by html tag only input field with out label
            if ( isset( $attr['field_enclose'] ) ) {
                $enclose = $attr['field_enclose'];
                $encloseTag = explode( ' ', trim( $enclose ) );
                $encloseTag = $encloseTag[0];
                $html = "<$enclose>$html</$encloseTag>";
            }

            //Add lebel if required
            $label_class = $label_class ? $label_class : 'pm_label';
            if ( isset( $attr['label'] ) ) {
                $for = isset( $attr['id'] ) ? "for='{$attr['id']}'" : '';
                $label_html = "<label class='$label_class' $for>{$attr['label']} {$label_extra}</label>";
                if ( isset( $attr['label_enclose'] ) ) {
                    $enclose = $attr['label_enclose'];
                    $encloseTag = explode( ' ', trim( $enclose ) );
                    $encloseTag = $encloseTag[0];
                    $label_html = "<$enclose>$label_html</$encloseTag>";
                }
            }

            //Enclose by other html element
            if ( isset( $attr['enclose'] ) ) {
                $enclose = $attr['enclose'];
                $encloseTag = explode( ' ', trim( $enclose ) );
                $encloseTag = $encloseTag[0];
                //$output = "<$enclose>$label_html $html</$encloseTag>";
                $html = "<$enclose>$label_html $html $field_control</$encloseTag>";
            }


            return $html;

        }

        /**
         * $message : Message content
         * $class : success error info warning validation
         * $inAdmin : Which area
         */
        function showMessage( $message, $class = 'success', $inAdmin = false ) {
            $class = 'pc_' . $class;
            $html = '';
            $html .= $inAdmin ? "<div class='updated'><p>$message</p></div>" : "<div class='$class'>$message</div>";

            return $html;
        }


        //
        function generate_thumb( $file, $width, $height, $crop = false ) {


            $uploads = wp_upload_dir();

            if ( @preg_match( '/\/wp-content\/uploads\//', $file, $match ) ) {

                $fullPath = $uploads['basedir'] . str_replace( $uploads['baseurl'], '', $file );
                $fullUrl = $file;

            } else {
                $fullPath = $uploads['basedir'] . $file;
                $fullUrl = $uploads['baseurl'] . $file;
            }
            $fileData = pathinfo( $fullPath );
            $fileName = $fileData['basename'];

            if ( !file_exists( $fullPath ) ) return;

            // In case of image
            if ( is_array( getimagesize( "$fullPath" ) ) ) {
                if ( !empty( $width ) && !empty( $height ) ) {
                    $resizedImage = wp_get_image_editor( $fullPath );
                    if ( is_wp_error( $resizedImage ) ) {
                        $error[] = $resizedImage->get_error_message();
                    }
                    if ( !isset( $error ) ) {
                        $resizedImage->resize( $width, $height, $crop );
                        $resizedImage->save( $fullPath );
                        $fullUrl = str_replace( $uploads['basedir'], $uploads['baseurl'], $resizedImage );
                    }
                }
                return $fullUrl;
            }

        }
    }
endif;