<?php
/**
 * @var array $meta_box
 * @var string $post_type
 * @var numeric $loop
 * @var boolean $toggle
 * @var string $id
 */
global $postMeta;
if ( !$meta_box['title'] ) {
    $meta_box['title'] = 'Untitled Group' . $id;
}
?>
<div class='meta-group meta-box-sortables'>
    <div id="group_<?php echo absint( $id ) ?>"
         class='postbox<?php echo ( ( !empty( $loop ) && $loop == 1 ) || !empty( $toggle ) ) ? '' : ' closed' ?>'>
        <div class="postbox-header">
            <div class='pm_trash' title='Click to Remove' onclick='meta_option_remove_meta_box(this);'></div>
            <button type="button" class="handlediv" onclick='meta_option_toggole(this);' aria-expanded="true"><span
                        class="screen-reader-text">Toggle panel: Listing Details</span><span class="toggle-indicator"
                                                                                             aria-hidden="true"></span>
            </button>
            <h3 class='hndle'><?php printf( '%s ID %s', esc_html( $meta_box['title'] ), esc_html( $id ) ) ?></h3>
        </div>
        <div class='inside'>
            <div class='meta_box_info'>
                <?php
                $html = $postMeta->create_input( "group[$id][title]", "text", [
                    "value"   => $meta_box['title'],
                    "label"   => "Group Name",
                    "id"      => "pm_group_$id",
                    "class"   => "pm_input validate[required]",
                    "onkeyup" => "moChangeGroupTitle(this)",
                    "enclose" => "div class='pm_segment'",
                ] );
                $html .= $postMeta->create_input( "group[$id][context]", "select", [
                    "value"   => $meta_box['context'] ?? 'advanced',
                    "label"   => "Context",
                    "class"   => "pm_input",
                    "enclose" => "div class='pm_segment'",
                    "by_key"  => true,
                ], [ 'normal' => 'Normal', 'advanced' => 'Advanced', 'side' => 'Side' ] );
                $html .= $postMeta->create_input( "group[$id][priority]", "select", [
                    "value"   => $meta_box['priority'] ?? null,
                    "label"   => "Priority",
                    "class"   => "pm_input",
                    "enclose" => "div class='pm_segment'",
                    "by_key"  => true,
                ], [ 'high' => 'High', 'core' => 'Core', 'default' => 'Default', 'low' => 'Low' ] );
                $html .= $postMeta->create_input( "group[$id][meta_key]", "text", [
                    "value"    => $post_type . "_" . $id,
                    "label"    => "Meta Key",
                    "id"       => "pm_group_$id",
                    "class"    => "pm_input pm_group_meta_key validate[required,custom[onlyLcNs]]",
                    "readonly" => "true",
                    "after"    => "<div class='pm_note pm_required'>Must be unique and have no space</div>",
                    "enclose"  => "div class='pm_segment'",
                ] );
                $groupMetakeyEdit = $postMeta->create_input( "", "checkbox", [
                    "value"   => null,
                    "class"   => "edit_meta_key",
                    "onclick" => "editMetaKey(this)",
                    "after"   => " Edit Group Metakey <br />",
                ] );
                $groupDuplicate = $postMeta->create_input( "group[$id][duplicate]", "checkbox", [
                    "value"    => $meta_box['duplicate'] ?? null,
                    "disabled" => ( $postMeta->isPro() ) ? null : "disabled",
                    "after"    => ( $postMeta->isPro() ) ? " Allow Duplicate" : "Allow Duplicate (Only for Pro)",
                ] );
                $html .= "<div class='pm_segment group_control'>" . wp_unslash( $groupMetakeyEdit . $groupDuplicate ) . "</div>";
                $html .= "</div>";
                PmFns::print_html( $html, true );
                echo "<input type='hidden' name='group[" . esc_attr( $id ) . "][post_type]' value='" . esc_attr( $post_type ) . "' />";
                $pmFieldList = $postMeta->pmFields();
                ?>
                <div class="metabox-option-list">
                    <div class="metabox-fields-holder ui-sortable ui-droppable">
                        <?php
                        if ( !empty( $meta_box['field'] ) ) {
                            $j = 0;
                            foreach ( $meta_box['field'] as $field ):
                                $j++;
                                $postMeta->getRender( "field", [
                                    'field'     => $field,
                                    'id'        => $j,
                                    'group_id'  => $id,
                                    'toggle'    => '',
                                    'post_type' => $meta_box['post_type']
                                ], 'postmeta' );
                            endforeach;
                        } else {
                            echo "<div class='pm-not-found'>No field found</div>";
                        }
                        ?>
                    </div>
                    <div class="meta-option-fields-list">
                        <div class='postbox'>
                            <div class="postbox-header">
                                <h3 class='hndle'>Available Field List</h3>
                            </div>
                            <div class='inside pm-field-list'>
                                <?php
                                foreach ( $pmFieldList as $fieldKey => $fieldValue ) {
                                    echo "<div data-field_type='" . esc_attr( $fieldKey ) . "' data-post_type='" . esc_attr( $post_type ) . "' data-group_id='" . esc_attr( $id ) . "' class='button meta_option_field_selector'>" . esc_html( $fieldValue['title'] ) . "<span /></div>";
                                } ?>
                            </div>
                        </div>
                    </div>
                </div>
                <input type="hidden" class="group_count" value="<?php echo esc_attr( $id ); ?>"/>
                <?php $maxKey = !empty( $meta_box['field'] ) ? $postMeta->maxKey( $meta_box['field'] ) : 0; ?>
                <?php $last_field_id = $maxKey ?: 0 ?>
                <input type="hidden" id="last_<?php echo esc_attr( $id ); ?>_field_id"
                       value="<?php echo esc_attr( $last_field_id ); ?>"/>
