<?php
/**
 * @var array $data
 */
global $postMeta;
$data = wp_parse_args( !empty( $data ) && is_array( $data ) ? $data : [], [
    'type'   => null,
    'labels' => [],
    'option' => []
] );
if ( !empty( $data['type'] ) ) {
    $title = sprintf( "Edit your custom post type :( %s )", esc_html( $data['type'] ) );
    $hidden = "<input type='hidden' name='edit' value='edit' /><input type='hidden' name='edit_key' value='" . esc_attr( $editKey ) . "' />";
} else {
    $title = "Add new custom post type";
    $hidden = '';
}
?>
<div class="widefat stuffbox metabox-holder" style="padding: 0 !important;">
    <h3><?php echo esc_html( $title ); ?></h3>
    <div class="inside" style="padding:10px 10px;">
        <div class="msg"></div>
        <form>
            <?php wp_nonce_field( 'nonce', 'pm_nonce' ); ?>
            <div id="pm_tabs" style="padding: 10px;">
                <ul>
                    <li><a href="#options"><span>Options</span></a></li>
                    <li><a href="#advanced-label"><span>Advanced Label Options</span></a></li>
                    <li><a href="#advanced-options"><span>Advanced Options</span></a></li>
                </ul>
                <div id="options">
                    <?php $postMeta->render( "postTypeOptions", [
                        'postType' => $data
                    ], 'posttype' ); ?>
                </div>
                <div id="advanced-label">
                    <?php $postMeta->render( "postTypeAdvLabel", [
                        'postType' => $data['labels']
                    ], 'posttype' ); ?>
                </div>
                <div id="advanced-options">
                    <?php $postMeta->render( "postTypeAdvOptions", [
                        'postType' => $data['option']
                    ], 'posttype' ); ?>
                </div>
            </div>

            <p>
                <?php PmFns::print_html( $hidden, true ); ?>
                <input type="button" class="button button-primary" id="pm_posttype_form_btn"
                       value="<?php echo esc_attr( !empty( $data['type'] ) ? "Update Custom Post Type" : 'Create Custom Post Type' ); ?>"/>
            </p>

        </form>
        <div class="msg"></div>
    </div>
</div>
<script type="text/javascript">
    jQuery(function () {
        jQuery("#pm_tabs").tabs();
    });
</script>