<?php

global $postMeta;
$postType = wp_parse_args( !empty( $postType ) && is_array( $postType ) ? $postType : [], [
    'public'              => true,
    'publicly_queryable'  => true,
    'exclude_from_search' => false,
    'show_ui'             => true,
    'show_in_menu'        => true,
    'menu_position'       => null,
    'capability_type'     => 'post',
    'hierarchical'        => false,
    'has_archive'         => false,
    'has_archive_slug'    => null,
    'rewrite'             => false,
    'rewrite_slug'        => null,
    'query_var'           => true,
    'can_export'          => true,
    'show_in_nav_menus'   => true,
] );
$html = '';
$html .= $postMeta->create_input( "pm_posttype[option][public]", "checkbox", [
    "value"         => $postType['public'],
    "label"         => "Public",
    "id"            => "pm_posttype_option_public",
    "class"         => "",
    "before"        => "<input name='pm_posttype[option][public]' id='pm_pt_checkbox_public_' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Meta argument used to define default values for publicly_queriable, show_ui, show_in_nav_menus and exclude_from_search.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][publicly_queryable]", "checkbox", [
    "value"         => $postType['publicly_queryable'],
    "label"         => "Publicly queryable",
    "id"            => "pm_posttype_option_publicly_queryable",
    "class"         => "",
    "before"        => "<input name='pm_posttype[option][publicly_queryable]' id='pm_pt_checkbox_publicly_queryable_' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Whether post_type queries can be performed from the front end.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][exclude_from_search]", "checkbox", [
    "value"         => $postType['exclude_from_search'],
    "label"         => "Exclude from search",
    "id"            => "pm_posttype_option_exclude_from_search",
    "class"         => "",
    "after"         => "<div class='pm_note'>Whether to exclude posts with this post type from search results.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][show_ui]", "checkbox", [
    "value"         => $postType['show_ui'],
    "label"         => "Show ui",
    "id"            => "pm_posttype_option_show_ui",
    "class"         => "",
    "before"        => "<input name='pm_posttype[option][show_ui]' id='pm_pt_checkbox_show_ui_' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Whether to generate a default UI for managing this post type. Note that _built-in post types, such as post and page, are intentionally set to false.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][show_in_menu]", "checkbox", [
    "value"         => $postType['show_in_menu'],
    "label"         => "Show in menu",
    "id"            => "pm_posttype_option_show_in_menu",
    "class"         => "",
    "before"        => "<input name='pm_posttype[option][show_in_menu]' id='pm_pt_checkbox_show_in_menuz_' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Whether to show the post type in the admin menu and where to show that menu. Note that show_ui must be true.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][menu_position]", "text", [
    "value"         => $postType['menu_position'],
    "label"         => "Menu position",
    "id"            => "pm_posttype_option_menu_position",
    "class"         => "pm_input",
    "after"         => "<div class='pm_note'>The position in the menu order the post type should appear.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'",
] );
$html .= $postMeta->create_input( "pm_posttype[option][capability_type]", "text", [
    "value"         => $postType['capability_type'],
    "label"         => "Capability type",
    "label_extra"   => "<span class='pm_required'>*</span>",
    "id"            => "pm_posttype_option_capability_type",
    "class"         => "pm_input validate[required]",
    "after"         => "<div class='pm_note'>Capability type (post,page) in Singular</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'",
] );
$html .= $postMeta->create_input( "pm_posttype[option][hierarchical]", "checkbox", [
    "value"         => $postType['hierarchical'],
    "label"         => "Hierarchical",
    "id"            => "pm_posttype_option_hierarchical",
    "class"         => "",
    "after"         => "<div class='pm_note'>Whether the post type is hierarchical. Allows Parent to be specified</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][has_archive]", "checkbox", [
    "value"         => $postType['has_archive'],
    "label"         => "Has archive",
    "id"            => "pm_posttype_option_has_archive",
    "class"         => "",
    "after"         => "<div class='pm_note'>Enables post type archives. Will use string as archive slug. Will generate the proper rewrite rules if rewrite is enabled.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][has_archive_slug]", "text", [
    "value"         => $postType['has_archive_slug'],
    "label"         => "Archive slug",
    "id"            => "pm_posttype_option_has_archive_slug",
    "class"         => "pm_input",
    "after"         => "<div class='pm_note'>Archive slug. The archive for the post type can be viewed at this slug. Has archives must be checked for this to work.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'",
] );
$html .= $postMeta->create_input( "pm_posttype[option][rewrite]", "checkbox", [
    "value"         => $postType['rewrite'],
    "label"         => "Rewrite",
    "id"            => "pm_posttype_option_rewrite",
    "class"         => "",
    "after"         => "<div class='pm_note'>Rewrite permalinks with this format. False to prevent rewrite.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][rewrite_slug]", "text", [
    "value"         => $postType['rewrite_slug'],
    "label"         => "Rewrite",
    "id"            => "pm_posttype_option_rewrite_slug",
    "class"         => "pm_input",
    "after"         => "<div class='pm_note'>Prepend posts with this slug - defaults to post type's name</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'",
] );
$html .= $postMeta->create_input( "pm_posttype[option][query_var]", "checkbox", [
    "value"         => $postType['query_var'],
    "label"         => "Query var",
    "id"            => "pm_posttype_option_query_var",
    "class"         => "",
    "before"        => "<input name='pm_posttype[option][query_var]' id='pm_pt_checkbox_query_var_' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>False to prevent queries, or string value of the query var to use for this post type.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][can_export]", "checkbox", [
    "value"         => $postType['can_export'],
    "label"         => "Can export",
    "id"            => "pm_posttype_option_can_export",
    "class"         => "",
    "before"        => "<input name='pm_posttype[option][can_export]' id='pm_pt_checkbox_can_export_' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Can this post_type be exported.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_posttype[option][show_in_nav_menus]", "checkbox", [
    "value"         => $postType['show_in_nav_menus'],
    "label"         => "Show in nav menus",
    "id"            => "pm_posttype_option_show_in_nav_menus",
    "class"         => "",
    "before"        => "<input name='pm_posttype[option][show_in_nav_menus]' id='pm_pt_checkbox_show_in_nav_menus_' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Whether post_type is available for selection in navigation menus.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );

return $html;
?>