<?php
/**
 * @var array $data
 * @var string $editKey
 */
global $postMeta;

if ( !empty( $data ) ) {
    $title = "Edit your custom taxonomy :( {$data['type']} )";
    $hidden = "<input type='hidden' name='edit' value='edit' /><input type='hidden' name='edit_key' value='" . esc_attr( $editKey ) . "' />";
    $button_txt = "Update Custom Taxonomy";
} else {
    $title = "Add new custom Taxonomy";
    $hidden = '';
    $button_txt = 'Create Custom Taxonomy';
}
?>
<div class="widefat stuffbox metabox-holder" style="padding: 0 !important;">
    <h3><?php echo esc_html( $title ); ?></h3>
    <div class="inside" style="padding:10px 10px;">
        <div class="msg"></div>
        <form>
            <div id="pm_tabs" style="padding: 10px;">
                <ul>
                    <li><a href="#options"><span>Options</span></a></li>
                    <li><a href="#advanced-label"><span>Advanced Label Options</span></a></li>
                    <li><a href="#advanced-options"><span>Advanced Options</span></a></li>
                </ul>
                <div id="options">
                    <?php $postMeta->render( "taxonomyOptions", [ 'taxonomy' => $data ?? [] ], 'taxonomy' ); ?>
                </div>
                <div id="advanced-label">
                    <?php $postMeta->render( "taxonomyAdvLabel", [ 'taxonomy' => isset( $data ) ? $data['labels'] : '' ], 'taxonomy' ); ?>
                </div>
                <div id="advanced-options">
                    <?php $postMeta->render( "taxonomyAdvOptions", [ 'taxonomy' => $data['option'] ?? [] ], 'taxonomy' ); ?>
                </div>
            </div>

            <p>
                <?php PmFns::print_html( $hidden, true ); ?>
                <input type="button" class="button button-primary" id="pm_taxonomy_form_btn"
                       value="<?php echo esc_attr( $button_txt ); ?>"/>
            </p>

        </form>
        <div class="msg"></div>
    </div>
</div>
<script type="text/javascript">
    jQuery(function () {
        jQuery("#pm_tabs").tabs();
    });


</script>