<?php
/**
 * @var array $taxonomy
 */
global $postMeta;

$taxonomy = wp_parse_args( $taxonomy, [
    'public'                => true,
    'show_in_nav_menus'     => true,
    'show_ui'               => true,
    'show_tagcloud'         => false,
    'hierarchical'          => true,
    'update_count_callback' => null,
    'rewrite'               => false,
    'rewrite_slug'          => null,
    'query_var'             => true,
] );

$html = '';
$html .= $postMeta->create_input( "pm_taxonomy[option][public]", "checkbox", [
    "value"         => $taxonomy['public'],
    "label"         => "Public",
    "id"            => "pm_taxonomy_option_public",
    "class"         => "",
    "before"        => "<input name='pm_taxonomy[option][public]' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Should this taxonomy be exposed in the admin UI.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_taxonomy[option][show_in_nav_menus]", "checkbox", [
    "value"         => $taxonomy['show_in_nav_menus'],
    "label"         => "Show in nav menus",
    "id"            => "pm_taxonomy_option_show_in_nav_menus",
    "class"         => "",
    "before"        => "<input name='pm_taxonomy[option][show_in_nav_menus]' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>true makes this taxonomy available for selection in navigation menus.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_taxonomy[option][show_ui]", "checkbox", [
    "value"         => $taxonomy['show_ui'],
    "label"         => "Show ui",
    "id"            => "pm_taxonomy_option_show_ui",
    "class"         => "",
    "before"        => "<input name='pm_taxonomy[option][show_ui]' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Whether to generate a default UI for managing this taxonomy.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_taxonomy[option][show_tagcloud]", "checkbox", [
    "value"         => $taxonomy['show_tagcloud'],
    "label"         => "Show tagcloud",
    "id"            => "pm_taxonomy_option_show_tagcloud",
    "class"         => "",
    "after"         => "<div class='pm_note'>Wether to allow the Tag Cloud widget to use this taxonomy.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_taxonomy[option][hierarchical]", "checkbox", [
    "value"         => $taxonomy['hierarchical'],
    "label"         => "Hierarchical",
    "id"            => "pm_taxonomy_option_hierarchical",
    "class"         => "",
    "before"        => "<input name='pm_taxonomy[option][hierarchical]' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>Is this taxonomy hierarchical (have descendants) like categories or not hierarchical like tags.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_taxonomy[option][update_count_callback]", "text", [
    "value"         => $taxonomy['update_count_callback'],
    "label"         => "Update count callback",
    "id"            => "pm_taxonomy_option_update_count_callback",
    "class"         => "pm_input",
    "after"         => "<div class='pm_note'>A function name that will be called to update the count of an associated, such as post, is updated.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'",
] );
$html .= $postMeta->create_input( "pm_taxonomy[option][rewrite]", "checkbox", [
    "value"         => $taxonomy['rewrite'],
    "label"         => "Rewrite",
    "id"            => "pm_taxonomy_option_rewrite",
    "class"         => "",
    "after"         => "<div class='pm_note'>Set to false to prevent rewrite, Default will use as query var</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );
$html .= $postMeta->create_input( "pm_taxonomy[option][rewrite_slug]", "text", [
    "value"         => $taxonomy['rewrite_slug'],
    "label"         => "Rewrite slug",
    "id"            => "pm_taxonomy_option_rewrite_slug",
    "class"         => "pm_input",
    "after"         => "<div class='pm_note'>Prepend posts with this slug - defaults to taxonomy's name</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'",
] );
$html .= $postMeta->create_input( "pm_taxonomy[option][query_var]", "checkbox", [
    "value"         => $taxonomy['query_var'],
    "label"         => "Query var",
    "id"            => "pm_taxonomy_option_query_var",
    "class"         => "",
    "before"        => "<input name='pm_taxonomy[option][query_var]' type='hidden' value='0'>",
    "after"         => "<div class='pm_note'>False to prevent queries, or string to customize query var. Default will use as query var.</div>",
    "field_enclose" => "div class='pm_field_item'",
    "enclose"       => "div class='pm_field'"
] );

return $html;